"use strict";

require("../../mocha-config");

var MapsAdminPanel = require('../../../../main/js/gui/admin/MapsAdminPanel');
var ServerConnector = require('../../ServerConnector-mock');
var logger = require('../../logger');

var assert = require('assert');

describe('MapsAdminPanel', function () {

  it('refresh', function () {
    var mapTab;
    var project;
    return ServerConnector.getProject().then(function (result) {
      project = result;
      return ServerConnector.getConfiguration();
    }).then(function (configuration) {
      mapTab = new MapsAdminPanel({
        element: testDiv,
        project: project,
        configuration: configuration
      });
      return mapTab.init();
    }).then(function () {
      return mapTab.onRefreshClicked();
    }).then(function () {
      assert.equal(0, logger.getWarnings().length);
      return mapTab.destroy();
    });
  });
  it('showLogs', function () {
    var mapTab;
    var project;
    return ServerConnector.getProject().then(function (result) {
      project = result;
      return ServerConnector.getConfiguration();
    }).then(function (configuration) {
      mapTab = new MapsAdminPanel({
        element: testDiv,
        project: project,
        configuration: configuration
      });
      return mapTab.init();
    }).then(function () {
      return mapTab.showLogs(project.getProjectId(), 'error');
    }).then(function () {
      assert.equal(0, logger.getWarnings().length);
      return mapTab.destroy();
    });
  });


  describe('onAddClicked', function () {
    it('default', function () {
      var mapTab;
      var project;
      return ServerConnector.getProject().then(function (result) {
        project = result;
        return ServerConnector.getConfiguration();
      }).then(function (configuration) {
        mapTab = new MapsAdminPanel({
          element: testDiv,
          project: project,
          configuration: configuration
        });
        return mapTab.init();
      }).then(function () {
        return mapTab.onAddClicked();
      }).then(function () {
        return mapTab.destroy();
      });
    });
    it('close and reopen', function () {
      var mapTab;
      var project;
      return ServerConnector.getProject().then(function (result) {
        project = result;
        return ServerConnector.getConfiguration();
      }).then(function (configuration) {
        mapTab = new MapsAdminPanel({
          element: testDiv,
          project: project,
          configuration: configuration
        });
        return mapTab.init();
      }).then(function () {
        return mapTab.onAddClicked();
      }).then(function () {
        mapTab._addDialog.close();
        return mapTab.onAddClicked();
      }).then(function () {
        return mapTab.destroy();
      });
    });
  });

});
